<copyright> MutablePointerArray class.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 2000 Pieter J. Schoenmakers.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: MutablePointerArray.t,v 1.1 2000/05/13 08:27:44 tiggr Exp $</id>
    </copyright>

implementation class 
MutablePointerArray: PointerArray, MutableArray

end;

implementation instance 
MutablePointerArray

void
  add pointer d
{
  [self set d at length];
}

void
  freeze
{
  //  isa = [PointerArray self];
}

extern id
  initWithCapacity int capacity;

protected id
  initWithEnumerator Enumerator e
{
  [super (PointerArray) initWithEnumerator e];

  capacity = length;

  = self;
}

extern pointer
  removeAt int index;

Any
  removeAt int index
{

  pointer d = [self removeAt index];

  = Any ([Pointer with d]);
}

extern void 
  removeElements (int, int) (start, length);

extern void
  resize (int, int) (start, num);

extern void
  set pointer d
   at int index;

void
  set All object
   at int index
{
  [self set [Pointer (object) value] at index];
}

extern void
  swap (int, int) (i, j);

end;
